/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin editor.

  ==============================================================================
*/

#include "PluginProcessor.h"
#include "PluginEditor.h"

//==============================================================================
GainControlAudioProcessorEditor::GainControlAudioProcessorEditor (GainControlAudioProcessor& p)
    : AudioProcessorEditor (&p), processor (p)
{
    // Make sure that before the constructor has finished, you've set the
    // editor's size to whatever you need it to be.
    setSize (400, 300);
    
    addAndMakeVisible(periodSlider);
    periodSlider.setRange(10.0, 500.0);
    periodSlider.setValue(300);
    periodSlider.onValueChange = [this] {
        processor.setPeriod(periodSlider.getValue());  
    };
}

GainControlAudioProcessorEditor::~GainControlAudioProcessorEditor()
{
}

//==============================================================================
void GainControlAudioProcessorEditor::paint (Graphics& g)
{
    // (Our component is opaque, so we must completely fill the background with a solid colour)
    g.fillAll (getLookAndFeel().findColour (ResizableWindow::backgroundColourId));
}

void GainControlAudioProcessorEditor::resized()
{
    periodSlider.setBounds(0,0,getWidth(),30);
}
